<!DOCTYPE html>
<html>
  <head>
    <title>Back Office Magasin</title>
    <link rel='stylesheet' href='/stylesheets/style.css' />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.2/css/bootstrap.min.css">
  </head>
  <body>
  <h1>Back Office Magasin</h1>
  <div class="row">
    <div class="card col-md-12" style="margin-bottom: 10px">
      <div class="card-body">
        <h2>Store Stock Position</h2>
        <button class="btn btn-outline-primary" style="margin-bottom: 10px" type="button" onclick="updateSales()">Update with sales</button>
        <button class="btn btn-outline-primary" style="margin-bottom: 10px" type="button" onclick="updateRestocking()">Update with deliveries</button>
        <table class="table">
          <thead class="thead-dark">
          <tr>
            <th scope="col">Product Code</th>
            <th scope="col">Quantity</th>
            <th scope="col">Store ID</th>
          </tr>
          </thead>
          <tbody id="store-table-body">

          </tbody>
        </table>
      </div>
    </div>
    <div class="card col-md-12">
      <div class="card-body">
        <h2>Delivery List</h2>
        <button class="btn btn-outline-primary" style="margin-bottom: 10px" type="button" onclick="updateDeliveries()">Update</button>
        <table class="table">
          <thead class="thead-dark">
          <tr>
            <th scope="col">Product Code</th>
            <th scope="col">Quantity</th>
            <th scope="col">Delivery ID</th>
            <th scope="col">WareHouse</th>
            <th scope="col">Shipping Date</th>
            <th scope="col">Date of Receipt</th>
          </tr>
          </thead>
          <tbody id="delivery-table-body">

          </tbody>
        </table>
      </div>
    </div>
    <script>
      window.addEventListener('load', function() {
        var tbody = document.getElementById('store-table-body');
        fetch('https://localhost:8443/back-office-magasin/back-office-magasin/store-stock-position').then(function(response) {
          response.json().then(function(stock) {
            for (let i = 0; i < stock.length; i++) {
              var store = stock[i];
              for (const product of store['product-quantity-map']) {
                var tr = document.createElement('tr');
                tr.appendChild(createTdChild(product['product-code']));
                tr.appendChild(createTdChild(product.quantity));
                tr.appendChild(createTdChild(store['store-id']));
                tbody.appendChild(tr);
              }
            }
          });
        });
      });

      function updateSales() {
        const tbody = document.getElementById('store-table-body');
        while (tbody.firstChild) {
          tbody.removeChild(tbody.firstChild);
        }
        fetch('https://localhost:8443/back-office-magasin/back-office-magasin/store-stock-movement/RemoveStock').then(function(response) {
          response.json().then(function(stock) {
            for (let i = 0; i < stock.length; i++) {
              var product = stock[i];
              var tr = document.createElement('tr');
              tr.appendChild(createTdChild(product['product-code']));
              tr.appendChild(createTdChild(product.quantity));
              tr.appendChild(createTdChild(product['store-id']));
              tbody.appendChild(tr);
            }
          });
        });
      }

      function updateRestocking() {
        const tbody = document.getElementById('store-table-body');
        while (tbody.firstChild) {
          tbody.removeChild(tbody.firstChild);
        }
        fetch('https://localhost:8443/back-office-magasin/back-office-magasin/store-stock-movement/InsertStock').then(function(response) {
          response.json().then(function(stock) {
            for (let i = 0; i < stock.length; i++) {
              var product = stock[i];
              var tr = document.createElement('tr');
              tr.appendChild(createTdChild(product['product-code']));
              tr.appendChild(createTdChild(product.quantity));
              tr.appendChild(createTdChild(product['store-id']));
              tbody.appendChild(tr);
            }
          });
        });
      }

      function updateDeliveries() {
        const tbody = document.getElementById('delivery-table-body');
        while (tbody.firstChild) {
          tbody.removeChild(tbody.firstChild);
        }
        fetch('https://localhost:8443/back-office-magasin/back-office-magasin/deliveries').then(function(response) {
          response.json().then(function(json) {
            for (let i = 0; i < json.deliveries.length; i++) {
              var delivery = json.deliveries[i];
              for (let j = 0; j < delivery['product-quantity-map'].length; j++) {
                var product = delivery['product-quantity-map'][j];
                var tr = document.createElement('tr');
                tr.appendChild(createTdChild(product['product-code']));
                tr.appendChild(createTdChild(product.quantity));
                tr.appendChild(createTdChild(delivery.id));
                tr.appendChild(createTdChild(delivery['warehouse-id']));
                tr.appendChild(createTdChild(delivery.shippingDate));
                tr.appendChild(createTdChild(delivery.receiptDate));
                tbody.appendChild(tr);
              }
            }
          });
        });
      }

      function createTdChild(element) {
        var td = document.createElement('td');
        td.appendChild(document.createTextNode(element));
        return td;
      }
    </script>
  </div>
  </body>
</html>
